SystemOrganization addCategory: #ConfigurationOfFuel!

Object subclass: #ConfigurationOfFuel
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfFuel'!

!ConfigurationOfFuel classSide methodsFor: 'development support' stamp: 'MartinDias 2/19/2011 03:09'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfFuel classSide methodsFor: 'private' stamp: 'MartinDias 2/19/2011 03:09'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfFuel classSide methodsFor: 'private' stamp: 'MartinDias 2/19/2011 03:09'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfFuel classSide methodsFor: 'private' stamp: 'MartinDias 2/19/2011 03:09'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfFuel classSide methodsFor: 'metacello tool support' stamp: 'MartinDias 2/19/2011 03:09'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfFuel classSide methodsFor: 'loading' stamp: 'MartinDias 2/19/2011 03:09'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfFuel classSide methodsFor: 'loading' stamp: 'MartinDias 2/19/2011 03:09'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfFuel classSide methodsFor: 'loading' stamp: 'MartinDias 2/19/2011 03:09'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfFuel classSide methodsFor: 'accessing' stamp: 'MartinDias 2/19/2011 03:09'!
project

	^self new project! !

!ConfigurationOfFuel classSide methodsFor: 'development support' stamp: 'MartinDias 2/19/2011 03:09'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfFuel methodsFor: 'baselines' stamp: 'MartinDias 2/19/2011 04:27'!
baseline10: spec 
        <version: '1.0-baseline'>
        
        spec for: #common do: [
                spec blessing: #baseline.
                spec repository: 'http://www.squeaksource.com/Fuel'.    

                spec 
                        package: 'Fuel';
                        package: 'FuelBenchmarks' with: [ spec requires: 'Fuel' ];
                        package: 'FuelBenchmarksMC2' with: [ 
					spec 
						requires: 'FuelBenchmarks';
						requires: 'Monticello2' ];
                        package: 'FuelBenchmarksMagma' with: [ 
					spec
						requires: 'FuelBenchmarks';
						requires: 'Magma' ].

                spec
				project: 'Monticello2' with: [
				spec
					className: 'ConfigurationOfMonticello2';
					loads: #('DEFAULT');
					file: 'ConfigurationOfMonticello2';
					repository: 'http://source.wiresong.ca/mc/' ].
                spec
				project: 'Magma' with: [
				spec
					className: 'ConfigurationOfMagma';
					loads: #('default');
					file: 'ConfigurationOfMagma';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].

                spec
                        group: 'default' with: #('Benchmarks');
                        group: 'Core' with: #('Fuel');
                        group: 'Benchmarks' with: #('FuelBenchmarks');
				group: 'MC2Benchmarks' with: #('FuelBenchmarksMC2');
				group: 'MagmaBenchmarks' with: #('FuelBenchmarksMagma') ].! !

!ConfigurationOfFuel methodsFor: 'accessing' stamp: 'MartinDias 2/19/2011 03:09'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfFuel methodsFor: 'symbolic versions' stamp: 'MartinDias 2/20/2011 17:12'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfFuel methodsFor: 'versions' stamp: 'MartinDias 2/20/2011 17:29'!
version10: spec 
        <version: '1.0' imports: #('1.0-baseline') >
        
        spec for: #common do: [
                spec blessing: #development.
                spec 
                        package: 'Fuel' with: 'Fuel-MartinDias.81';
                        package: 'FuelBenchmarks' with: 'FuelBenchmarks-MartinDias.4'].! !
